Index: /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90
===================================================================
--- /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 2232)
@@ -569,201 +1193,252 @@
        IF ( TRIM( most_method ) == 'newton' )  THEN
 
-          !$OMP PARALLEL DO PRIVATE( k, z_mo )
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-
-                k   = nzb_s_inner(j,i)
-                z_mo = zu(k+1) - zw(k)
-
-!
-!--             Store current value in case the Newton iteration fails
-                ol_old = ol(j,i)
+          DO  m = 1, surf%ns
+
+             i   = surf%i(m)            
+             j   = surf%j(m)
+             k   = surf%k(m)
+
+             z_mo = surf%z_mo(m)
+
+!
+!--          Store current value in case the Newton iteration fails
+             ol_old = surf%ol(m)
+
+!
+!--          Ensure that the bulk Richardson number and the Obukhov 
+!--          length have the same sign
+             IF ( surf%rib(m) * surf%ol(m) < 0.0_wp  .OR.                      &
+                  ABS( surf%ol(m) ) == ol_max )  THEN
+                IF ( surf%rib(m) > 1.0_wp ) surf%ol(m) =  0.01_wp
+                IF ( surf%rib(m) < 0.0_wp ) surf%ol(m) = -0.01_wp
+             ENDIF
+!
+!--          Iteration to find Obukhov length
+             iter = 0
+             DO
+                iter = iter + 1
+!
+!--             In case of divergence, use the value of the previous time step
+                IF ( iter > 1000 )  THEN
+                   surf%ol(m) = ol_old
+                   EXIT
+                ENDIF
+
+                ol_m = surf%ol(m)
+                ol_l = ol_m - 0.001_wp * ol_m
+                ol_u = ol_m + 0.001_wp * ol_m
+
+
+                IF ( ibc_pt_b /= 1 )  THEN
+!
+!--                Calculate f = Ri - [...]/[...]^2 = 0
+                   f = surf%rib(m) - ( z_mo / ol_m ) * (                       &
+                                                 LOG( z_mo / surf%z0h(m) )     &
+                                                 - psi_h( z_mo / ol_m )        &
+                                                 + psi_h( surf%z0h(m) /        &
+                                                          ol_m )               &
+                                                               )               &
+                                              / ( LOG( z_mo / surf%z0(m) )     &
+                                                 - psi_m( z_mo / ol_m )        &
+                                                 + psi_m( surf%z0(m) /         &
+                                                          ol_m )               &
+                                                 )**2
+
+!
+!--                 Calculate df/dL
+                    f_d_ol = ( - ( z_mo / ol_u ) * ( LOG( z_mo /               &
+                                                             surf%z0h(m) )     &
+                                            - psi_h( z_mo / ol_u )             &
+                                            + psi_h( surf%z0h(m) / ol_u )      &
+                                              )                                &
+                                            / ( LOG( z_mo / surf%z0(m) )       &
+                                            - psi_m( z_mo / ol_u )             &
+                                            + psi_m( surf%z0(m) / ol_u )       &
+                                              )**2                             &
+                           + ( z_mo / ol_l ) * ( LOG( z_mo / surf%z0h(m) )     &
+                                            - psi_h( z_mo / ol_l )             &
+                                            + psi_h( surf%z0h(m) / ol_l )      &
+                                              )                                &
+                                            / ( LOG( z_mo / surf%z0(m) )       &
+                                            - psi_m( z_mo / ol_l )             &
+                                            + psi_m( surf%z0(m) / ol_l )       &
+                                              )**2                             &
+                             ) / ( ol_u - ol_l )
+                ELSE
+!
+!--                Calculate f = Ri - 1 /[...]^3 = 0
+                   f = surf%rib(m) - ( z_mo / ol_m ) /                         &
+                                                ( LOG( z_mo / surf%z0(m) )     &
+                                            - psi_m( z_mo / ol_m )             &
+                                            + psi_m( surf%z0(m) / ol_m )       &
+                                                )**3
+
+!
+!--                Calculate df/dL
+                   f_d_ol = ( - ( z_mo / ol_u ) / ( LOG( z_mo /                &
+                                                            surf%z0(m) )       &
+                                            - psi_m( z_mo / ol_u )             &
+                                            + psi_m( surf%z0(m) / ol_u )       &
+                                                     )**3                      &
+                           + ( z_mo / ol_l ) / ( LOG( z_mo / surf%z0(m) )      &
+                                            - psi_m( z_mo / ol_l )             &
+                                            + psi_m( surf%z0(m) / ol_l )       &
+                                               )**3                            &
+                                  ) / ( ol_u - ol_l )
+                ENDIF
+!
+!--             Calculate new L
+                surf%ol(m) = ol_m - f / f_d_ol
 
 !
 !--             Ensure that the bulk Richardson number and the Obukhov 
-!--             lengtH have the same sign
-                IF ( rib(j,i) * ol(j,i) < 0.0_wp  .OR.                         &
-                     ABS( ol(j,i) ) == ol_max )  THEN
-                   IF ( rib(j,i) > 0.0_wp ) ol(j,i) =  0.01_wp
-                   IF ( rib(j,i) < 0.0_wp ) ol(j,i) = -0.01_wp
+!--             length have the same sign and ensure convergence.
+                IF ( surf%ol(m) * ol_m < 0.0_wp )  surf%ol(m) = ol_m * 0.5_wp
+!
+!--             If unrealistic value occurs, set L to the maximum
+!--             value that is allowed
+                IF ( ABS( surf%ol(m) ) > ol_max )  THEN
+                   surf%ol(m) = ol_max
+                   EXIT
                 ENDIF
 !
-!--             Iteration to find Obukhov length
-                iter = 0
-                DO
-                   iter = iter + 1
-!
-!--                In case of divergence, use the value of the previous time step
-                   IF ( iter > 1000 )  THEN
-                      ol(j,i) = ol_old
-                      EXIT
-                   ENDIF
-
-                   ol_m = ol(j,i)
-                   ol_l = ol_m - 0.001_wp * ol_m
-                   ol_u = ol_m + 0.001_wp * ol_m
-
-
-                   IF ( ibc_pt_b /= 1 )  THEN
-!
-!--                   Calculate f = Ri - [...]/[...]^2 = 0
-                      f = rib(j,i) - ( z_mo / ol_m ) * ( LOG( z_mo / z0h(j,i) )&
-                                                    - psi_h( z_mo / ol_m )     &
-                                                    + psi_h( z0h(j,i) / ol_m ) &
-                                                   )                           &
-                                                 / ( LOG( z_mo / z0(j,i) )     &
-                                                    - psi_m( z_mo / ol_m )     &
-                                                    + psi_m( z0(j,i) / ol_m )  &
-                                                    )**2
-
-!
-!--                    Calculate df/dL
-                       f_d_ol = ( - ( z_mo / ol_u ) * ( LOG( z_mo / z0h(j,i) ) &
-                                                   - psi_h( z_mo / ol_u )      &
-                                                   + psi_h( z0h(j,i) / ol_u )  &
-                                                 )                             &
-                                               / ( LOG( z_mo / z0(j,i) )       &
-                                                   - psi_m( z_mo / ol_u )      &
-                                                   + psi_m( z0(j,i) / ol_u )   &
-                                                 )**2                          &
-                              + ( z_mo / ol_l ) * ( LOG( z_mo / z0h(j,i) )     &
-                                                   - psi_h( z_mo / ol_l )      &
-                                                   + psi_h( z0h(j,i) / ol_l )  &
-                                                 )                             &
-                                               / ( LOG( z_mo / z0(j,i) )       &
-                                                   - psi_m( z_mo / ol_l )      &
-                                                   + psi_m( z0(j,i) / ol_l )   &
-                                                 )**2                          &
-                                ) / ( ol_u - ol_l )
-                   ELSE
-!
-!--                   Calculate f = Ri - 1 /[...]^3 = 0
-                      f = rib(j,i) - ( z_mo / ol_m ) / ( LOG( z_mo / z0(j,i) )&
-                                                    - psi_m( z_mo / ol_m )    &
-                                                    + psi_m( z0(j,i) / ol_m ) &
-                                                       )**3
-
-!
-!--                   Calculate df/dL
-                      f_d_ol = ( - ( z_mo / ol_u ) / ( LOG( z_mo / z0(j,i) )  &
-                                                   - psi_m( z_mo / ol_u )     &
-                                                   + psi_m( z0(j,i) / ol_u )  &
-                                                 )**3                         &
-                              + ( z_mo / ol_l ) / ( LOG( z_mo / z0(j,i) )     &
-                                                   - psi_m( z_mo / ol_l )     &
-                                                   + psi_m( z0(j,i) / ol_l )  &
-                                                 )**3                         &
-                                     ) / ( ol_u - ol_l )
-                   ENDIF
-!
-!--                Calculate new L
-                   ol(j,i) = ol_m - f / f_d_ol
-
-!
-!--                Ensure that the bulk Richardson number and the Obukhov 
-!--                length have the same sign and ensure convergence.
-                   IF ( ol(j,i) * ol_m < 0.0_wp )  ol(j,i) = ol_m * 0.5_wp
-
-!
-!--                If unrealistic value occurs, set L to the maximum
-!--                value that is allowed
-                   IF ( ABS( ol(j,i) ) > ol_max )  THEN
-                      ol(j,i) = ol_max
-                      EXIT
-                   ENDIF
-!
-!--                Check for convergence
-                   IF ( ABS( ( ol(j,i) - ol_m ) / ol(j,i) ) < 1.0E-4_wp )  THEN
-                      EXIT
-                   ELSE
-                      CYCLE
-                   ENDIF
-
+!--             Check for convergence
+                IF ( ABS( ( surf%ol(m) - ol_m ) /                              &
+                     surf%ol(m) ) < 1.0E-4_wp )  THEN
+                   EXIT
+                ELSE
+                   CYCLE
+                ENDIF
+
+             ENDDO
+          ENDDO
+
+       ELSEIF ( TRIM( most_method ) == 'lookup' )  THEN
+
+          !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo, li ) FIRSTPRIVATE( li_bnd ) LASTPRIVATE( li_bnd )
+          DO  m = 1, surf%ns
+
+             i   = surf%i(m)            
+             j   = surf%j(m)
+             k   = surf%k(m)
+!
+!--          If the bulk Richardson number is outside the range of the lookup
+!--          table, set it to the exceeding threshold value
+             IF ( surf%rib(m) < rib_min )  surf%rib(m) = rib_min
+             IF ( surf%rib(m) > rib_max )  surf%rib(m) = rib_max
+
+!
+!--          Find the correct index bounds for linear interpolation. As the
+!--          Richardson number will not differ very much from time step to
+!--          time step , use the index from the last step and search in the 
+!--          correct direction
+             li = li_bnd
+             IF ( rib_tab(li) - surf%rib(m) > 1.0_wp )  THEN
+                DO  WHILE ( rib_tab(li-1) - surf%rib(m) > 1.0_wp  .AND.  li > 1 )
+                   li = li-1
                 ENDDO
-                       
-             ENDDO
+             ELSE
+                DO  WHILE ( rib_tab(li) - surf%rib(m) < 0.0_wp                 &
+                           .AND.  li < num_steps-1 )
+                   li = li+1
+                ENDDO
+             ENDIF
+             li_bnd = li
+
+!
+!--          Linear interpolation to find the correct value of z/L
+             surf%ol(m) = ( ol_tab(li-1) + ( ol_tab(li) - ol_tab(li-1) )       &
+                         / (  rib_tab(li) - rib_tab(li-1) )                    &
+                         * ( surf%rib(m) - rib_tab(li-1) ) )
+
           ENDDO
 
-       ELSEIF ( TRIM( most_method ) == 'lookup' )  THEN
-
-          !$OMP PARALLEL DO PRIVATE( k, l, z_mo ) FIRSTPRIVATE( l_bnd ) LASTPRIVATE( l_bnd )
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-
-!
-!--             If the bulk Richardson number is outside the range of the lookup
-!--             table, set it to the exceeding threshold value
-                IF ( rib(j,i) < rib_min )  rib(j,i) = rib_min
-                IF ( rib(j,i) > rib_max )  rib(j,i) = rib_max
-
-!
-!--             Find the correct index bounds for linear interpolation. As the
-!--             Richardson number will not differ very much from time step to
-!--             time step , use the index from the last step and search in the 
-!--             correct direction
-                l = l_bnd
-                IF ( rib_tab(l) - rib(j,i) > 0.0_wp )  THEN
-                   DO  WHILE ( rib_tab(l-1) - rib(j,i) > 0.0_wp  .AND.  l > 0 )
-                      l = l-1
-                   ENDDO
-                ELSE
-                   DO  WHILE ( rib_tab(l) - rib(j,i) < 0.0_wp                  &
-                              .AND.  l < num_steps-1 )
-                      l = l+1
-                   ENDDO
-                ENDIF
-                l_bnd = l
-
-!
-!--             Linear interpolation to find the correct value of z/L
-                ol(j,i) = ( ol_tab(l-1) + ( ol_tab(l) - ol_tab(l-1) )          &
-                            / (  rib_tab(l) - rib_tab(l-1) )                   &
-                            * ( rib(j,i) - rib_tab(l-1) ) )
-
-             ENDDO
-          ENDDO
-
        ELSEIF ( TRIM( most_method ) == 'circular' )  THEN
 
-          !$OMP PARALLEL DO PRIVATE( k, z_mo )
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-
-                k   = nzb_s_inner(j,i)
-                z_mo = zu(k+1) - zw(k)
-
-                IF ( .NOT. humidity )  THEN
-                   ol(j,i) =  ( pt(k+1,j,i) *  us(j,i)**2 ) / ( kappa * g      &
-                              * ts(j,i) + 1E-30_wp )
-                ELSEIF ( cloud_physics )  THEN
-
-                   ol(j,i) =  ( vpt(k+1,j,i) * us(j,i)**2 ) / ( kappa * g      &
-                              * ( ts(j,i) + 0.61_wp * pt1(j,i) * qs(j,i)       &
-                              + 0.61_wp * qv1(j,i) * ts(j,i) - ts(j,i)         &
-                              * ql(k+1,j,i) ) + 1E-30_wp )
-                ELSE
-                   ol(j,i) =  ( vpt(k+1,j,i) *  us(j,i)**2 ) / ( kappa * g     &
-                              * ( ts(j,i) + 0.61_wp * pt(k+1,j,i) * qs(j,i)    &
-                                  + 0.61_wp * q(k+1,j,i) * ts(j,i) ) + 1E-30_wp )
-                ENDIF
+          IF ( .NOT. humidity )  THEN
+             !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
+             DO  m = 1, surf%ns
+
+                i   = surf%i(m)            
+                j   = surf%j(m)
+                k   = surf%k(m)
+
+                z_mo = surf%z_mo(m)
+
+                surf%ol(m) =  ( pt(k,j,i) *  surf%us(m)**2 ) /                 &
+                                       ( kappa * g *                           &
+                                         surf%ts(m) + 1E-30_wp )
 !
 !--             Limit the value range of the Obukhov length.
-!--             This is necessary for very small velocities (u,v --> 0), because
+!--             This is necessary for very small velocities (u,v --> 1), because
 !--             the absolute value of ol can then become very small, which in
 !--             consequence would result in very large shear stresses and very
 !--             small momentum fluxes (both are generally unrealistic).
-                IF ( ( z_mo / ( ol(j,i) + 1E-30_wp ) ) < zeta_min )            &
-                   ol(j,i) = z_mo / zeta_min
-                IF ( ( z_mo / ( ol(j,i) + 1E-30_wp ) ) > zeta_max )            &
-                   ol(j,i) = z_mo / zeta_max
-             ENDDO
-          ENDDO
+                IF ( ( z_mo / ( surf%ol(m) + 1E-30_wp ) ) < zeta_min )         &
+                   surf%ol(m) = z_mo / zeta_min
+                IF ( ( z_mo / ( surf%ol(m) + 1E-30_wp ) ) > zeta_max )         &
+                   surf%ol(m) = z_mo / zeta_max
+
+             ENDDO
+          ELSEIF ( cloud_physics )  THEN
+             !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
+             DO  m = 1, surf%ns
+
+                i   = surf%i(m)            
+                j   = surf%j(m)
+                k   = surf%k(m)
+
+                z_mo = surf%z_mo(m)
+
+
+                surf%ol(m) =  ( vpt(k,j,i) * surf%us(m)**2 ) /                 &
+                    ( kappa * g * ( surf%ts(m) +                               &
+                         0.61_wp * surf%pt1(m) * surf%us(m)                    &
+                       + 0.61_wp * surf%qv1(m) * surf%ts(m) -                  &
+                                   surf%ts(m)  * ql(k,j,i) ) + 1E-30_wp )
+!
+!--             Limit the value range of the Obukhov length.
+!--             This is necessary for very small velocities (u,v --> 1), because
+!--             the absolute value of ol can then become very small, which in
+!--             consequence would result in very large shear stresses and very
+!--             small momentum fluxes (both are generally unrealistic).
+                IF ( ( z_mo / ( surf%ol(m) + 1E-30_wp ) ) < zeta_min )         &
+                   surf%ol(m) = z_mo / zeta_min
+                IF ( ( z_mo / ( surf%ol(m) + 1E-30_wp ) ) > zeta_max )         &
+                   surf%ol(m) = z_mo / zeta_max
+
+             ENDDO
+          ELSE
+
+             !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
+             DO  m = 1, surf%ns
+
+                i   = surf%i(m)            
+                j   = surf%j(m)
+                k   = surf%k(m)
+
+                z_mo = surf%z_mo(m)
+
+                surf%ol(m) =  ( vpt(k,j,i) *  surf%us(m)**2 ) /                &
+                    ( kappa * g * ( surf%ts(m) + 0.61_wp * pt(k,j,i) *         &
+                                    surf%qs(m) + 0.61_wp * q(k,j,i)  *         &
+                                    surf%ts(m) ) + 1E-30_wp )
+
+!
+!--             Limit the value range of the Obukhov length.
+!--             This is necessary for very small velocities (u,v --> 1), because
+!--             the absolute value of ol can then become very small, which in
+!--             consequence would result in very large shear stresses and very
+!--             small momentum fluxes (both are generally unrealistic).
+                IF ( ( z_mo / ( surf%ol(m) + 1E-30_wp ) ) < zeta_min )         &
+                   surf%ol(m) = z_mo / zeta_min
+                IF ( ( z_mo / ( surf%ol(m) + 1E-30_wp ) ) > zeta_max )         &
+                   surf%ol(m) = z_mo / zeta_max
+
+             ENDDO
+
+          ENDIF
 
        ENDIF
-
-!
-!--    Values of ol at ghost point locations are needed for the evaluation
-!--    of usws and vsws.
-       CALL exchange_horiz_2d( ol )
 
     END SUBROUTINE calc_ol
@@ -775,18 +1450,51 @@
        IMPLICIT NONE
 
-       !$OMP PARALLEL DO PRIVATE( k, z_mo )
-       DO  i = nxlg, nxrg
-          DO  j = nysg, nyng
-
-             k   = nzb_s_inner(j,i)+1
-             z_mo = zu(k+1) - zw(k)
-
-!
-!--          Compute u* at the scalars' grid points
-             us(j,i) = kappa * uv_total(j,i) / ( LOG( z_mo / z0(j,i) )         &
-                                          - psi_m( z_mo / ol(j,i) )            &
-                                          + psi_m( z0(j,i) / ol(j,i) ) )
+       INTEGER(iwp) ::  m       !< loop variable over all horizontal surf elements 
+
+!
+!--    Compute u* at horizontal surfaces at the scalars' grid points
+       IF ( .NOT. surf_vertical )  THEN
+!
+!--       Compute u* at upward-facing surfaces
+          IF ( .NOT. downward )  THEN
+             !$OMP PARALLEL  DO PRIVATE( k, z_mo )
+             DO  m = 1, surf%ns
+
+                k    = surf%k(m)
+                z_mo = surf%z_mo(m)
+!
+!--             Compute u* at the scalars' grid points
+                surf%us(m) = kappa * surf%uvw_abs(m) /                         &
+                            ( LOG( z_mo / surf%z0(m) )                         &
+                           - psi_m( z_mo / surf%ol(m) )                        &
+                           + psi_m( surf%z0(m) / surf%ol(m) ) )
+   
+             ENDDO
+!
+!--       Compute u* at downward-facing surfaces. This case, do not consider
+!--       any stability. 
+          ELSE
+             !$OMP PARALLEL  DO PRIVATE( k, z_mo )
+             DO  m = 1, surf%ns
+
+                k    = surf%k(m)
+                z_mo = surf%z_mo(m)
+!
+!--             Compute u* at the scalars' grid points
+                surf%us(m) = kappa * surf%uvw_abs(m) / LOG( z_mo / surf%z0(m) )
+   
+             ENDDO
+          ENDIF
+!
+!--    Compute u* at vertical surfaces at the u/v/v grid, respectively. 
+!--    No stability is considered in this case.
+       ELSE
+          !$OMP PARALLEL DO PRIVATE( z_mo )
+          DO  m = 1, surf%ns
+             z_mo = surf%z_mo(m)
+
+             surf%us(m) = kappa * surf%uvw_abs(m) / LOG( z_mo / surf%z0(m) )
           ENDDO
-       ENDDO
+       ENDIF
 
     END SUBROUTINE calc_us
@@ -794,14 +1502,21 @@
 !
 !-- Calculate potential temperature and specific humidity at first grid level
+!-- ( only for upward-facing surfs )
     SUBROUTINE calc_pt_q
 
        IMPLICIT NONE
 
-       DO  i = nxlg, nxrg
-          DO  j = nysg, nyng
-             k   = nzb_s_inner(j,i)+1
-             pt1(j,i) = pt(k,j,i) + l_d_cp * pt_d_t(k) * ql(k,j,i)
-             qv1(j,i) = q(k,j,i) - ql(k,j,i)
-          ENDDO
+       INTEGER(iwp) ::  m       !< loop variable over all horizontal surf elements 
+
+       !$OMP PARALLEL DO PRIVATE( i, j, k )
+       DO  m = 1, surf%ns 
+
+          i   = surf%i(m)            
+          j   = surf%j(m)
+          k   = surf%k(m)
+
+          surf%pt1(m) = pt(k,j,i) + l_d_cp * pt_d_t(k) * ql(k,j,i)
+          surf%qv1(m) = q(k,j,i) - ql(k,j,i)
+
        ENDDO
 
